variables:
  GIT_SUBMODULE_STRATEGY: recursive

stages:
  - test
  - trigger_bitrise
  - trigger_bitrise_production

test:
  stage: trigger_bitrise
  image: cirrusci/flutter
  services:
    - docker:dind
  script:
    - test

trigger_bitrise:
  stage: trigger_bitrise
  image: curlimages/curl
  services:
    - docker:dind
  script:
    - trigger_build
  except:
    - master

trigger_bitrise_production:
  stage: trigger_bitrise_production
  image: curlimages/curl
  when: manual
  services:
    - docker:dind
  script:
    - trigger_build
  only:
    - master

.auto_devops: &auto_devops |

  function test() {
    cd application && flutter test
  }

  function trigger_build() {
    if [[ "$BITRISE_ACCESS_TOKEN" == "" || "$BITRISE_APP_SLUG" == "" ]]; then
      echo "Invalid BITRISE_ACCESS_TOKEN or BITRISE_APP_SLUG variables. Check and try again."
      exit 1
    fi

    # not working, but kept as a reference for
    #BITRISE_YML="`cat bitrise.yml`"
    #curl -X POST -H "Authorization: $BITRISE_ACCESS_TOKEN" \
    #  https://api.bitrise.io/v0.1/apps/$BITRISE_APP_SLUG/bitrise.yml -d \
    #  @bitrise.yml.json

    BUILD_ANDROID=0
    BUILD_IOS=0

    if [[ "$CI_COMMIT_REF_SLUG" != "master" && "$CI_COMMIT_REF_SLUG" != "staging" ]]; then
      if [[ `expr "$CI_COMMIT_MESSAGE" : '.*\#build\-android.*'` != 0 ]]; then
        BUILD_ANDROID=1
      elif [[ `expr "$CI_COMMIT_MESSAGE" : '.*\#build\-ios.*'` != 0 ]]; then
        BUILD_IOS=1
      elif [[ `expr "$CI_COMMIT_MESSAGE" : '.*\#build.*'` != 0 ]]; then
        # regular branches trigger only when the hashtag is present
        BUILD_ANDROID=1
        BUILD_IOS=1
      fi
    else
      # staging and master always trigger
      BUILD_ANDROID=1
      BUILD_IOS=1
    fi

    if [[ "$BUILD_ANDROID" == "1" && "$BUILD_IOS" == "1" ]]; then
      TARGETS_READABLE="Android and iOS"
      TARGETS_WORKFLOW=""
    elif [[ "$BUILD_ANDROID" == "1" ]]; then
      TARGETS_READABLE="Android only"
      TARGETS_WORKFLOW="-android"
    elif [[ "$BUILD_IOS" == "1" ]]; then
      TARGETS_READABLE="iOS only"
      TARGETS_WORKFLOW="-ios"
    fi


    if [[ "$BUILD_ANDROID" == "1" || "$BUILD_IOS" == "1" ]]; then
      echo "Triggering on-demand bitrise build(s) for $TARGETS_READABLE (branch '$CI_COMMIT_REF_SLUG')..."
    else
      echo "Skipping android build (no condition was met)."
    fi

    if [[ "$BUILD_ANDROID" == "1" ]]; then
      curl -X POST -H "Authorization: $BITRISE_ACCESS_TOKEN" \
        "https://api.bitrise.io/v0.1/apps/$BITRISE_APP_SLUG/builds" -d \
        "{\"hook_info\":{\"type\":\"bitrise\"},\"build_params\":{\"branch\":\"$CI_COMMIT_REF_SLUG\",\"workflow_id\":\"build-and-ship-android\"}}"
    fi

    if [[ "$BUILD_IOS" == "1" ]]; then
      curl -X POST -H "Authorization: $BITRISE_ACCESS_TOKEN" \
        "https://api.bitrise.io/v0.1/apps/$BITRISE_APP_SLUG/builds" -d \
        "{\"hook_info\":{\"type\":\"bitrise\"},\"build_params\":{\"branch\":\"$CI_COMMIT_REF_SLUG\",\"workflow_id\":\"build-and-ship-ios\"}}"
    fi
  }

before_script:
  - *auto_devops
